/*
 *		Copyright (C) 2013-2015, 2019 by the Konclude Developer Team.
 *
 *		This file is part of the reasoning system Konclude.
 *		For details and support, see <http://konclude.com/>.
 *
 *		Konclude is free software: you can redistribute it and/or modify
 *		it under the terms of version 3 of the GNU Lesser General Public
 *		License (LGPLv3) as published by the Free Software Foundation.
 *
 *		Konclude is distributed in the hope that it will be useful,
 *		but WITHOUT ANY WARRANTY; without even the implied warranty of
 *		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *		GNU (Lesser) General Public License for more details.
 *
 *		You should have received a copy of the GNU (Lesser) General Public
 *		License along with Konclude. If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef KONCLUDE_REASONER_QUERY_CVARIABLEBINDINGSANSWERSLISTRESULT_H
#define KONCLUDE_REASONER_QUERY_CVARIABLEBINDINGSANSWERSLISTRESULT_H

// Libraries includes
#include "CVariableBindingsAnswersResult.h"

// Namespace includes

// Other includes
#include <QList>

// Logger includes
#include "Logger/CLogger.h"



namespace Konclude {

	namespace Reasoner {

		namespace Query {

			/*! 
			 *
			 *		\class		CVariableBindingsAnswersListResult
			 *		\author		Andreas Steigmiller
			 *		\version	0.1
			 *		\brief		TODO
			 *
			 */
			class CVariableBindingsAnswersListResult : public CVariableBindingsAnswersResult {
				// public methods
				public:
					//! Constructor
					CVariableBindingsAnswersListResult(const QStringList& varNames);

					//! Destructor
					virtual ~CVariableBindingsAnswersListResult();

					virtual CVariableBindingsAnswersListResult* addResultVariableBindings(CVariableBindingsAnswerResult* varBindings, cint64 cardinality = 1);

					virtual CVariableBindingsAnswersListResult* setResultVariableBindingsList(const QList<CVariableBindingsAnswerResult*>& bindingList);
					virtual QList<CVariableBindingsAnswerResult*>* getResult();

					virtual CVariableBindingsAnswersResultIterator* getVariableBindingsAnswersIterator(CVariableBindingsAnswersResultIterator* reuseIt = nullptr);


					virtual const QStringList& getVariableNames();

					virtual QString getQueryResultString();
					virtual bool isResultEquivalentTo(CVariableBindingsAnswersListResult *otherQueryResult);
					virtual bool isResultEquivalentTo(CQueryResult *otherQueryResult);

					virtual cint64 getResultCount();


				// protected methods
				protected:

				// protected variables
				protected:
					QList<CVariableBindingsAnswerResult*> mBindingsList;
					QList<CVariableBindingsAnswerResult*> mBindingsContainer;
					QStringList mVariableNames;

				// private methods
				private:

				// private variables
				private:

			};

		}; // end namespace Query

	}; // end namespace Reasoner

}; // end namespace Konclude

#endif // KONCLUDE_REASONER_QUERY_CVARIABLEBINDINGSANSWERSLISTRESULT_H
